package cn.com.bril.androidocr.studio.http;

import android.util.Log;

import org.xutils.common.Callback;
import org.xutils.common.util.KeyValue;
import org.xutils.http.RequestParams;
import org.xutils.http.body.MultipartBody;
import org.xutils.x;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import cn.com.bril.androidocr.studio.configs.RequestConfig;
import cn.com.bril.androidocr.studio.interf.OnHttpListener;

import static com.bumptech.glide.gifdecoder.GifHeaderParser.TAG;

/**
 * Created by sunny on 2018-3-12.
 */

public class HttpHolder {

    //add
    public static void exportFile(String url,Map<String,Object> map,Callback.CommonCallback<String> callback){
        RequestParams params=new RequestParams(url);
        Iterator<Map.Entry<String,Object>> it = map.entrySet().iterator();
        while (it.hasNext()){
            Map.Entry<String,Object> entry = it.next();
            if(!"header".equals(entry.getKey()))
                params.addBodyParameter(entry.getKey(),String.valueOf(entry.getValue()));
            else
                params.addHeader("X-Auth-Token",String.valueOf(entry.getValue()));
        }
        x.http().post(params,callback);
    }

    public static String upLoadFile(String path, final OnHttpListener listener){

        String flg="";
        RequestParams params=new RequestParams(RequestConfig.UP_FILE);
        params.setConnectTimeout(10000);
        params.setReadTimeout(5000);
        //创建List<KeyValue>对象
        List<KeyValue> list = new ArrayList<>();
        //给list中添加数据，filePah是上传的文件路径，比如sd卡中图片
        list.add(new KeyValue("file", new File(path)));//文件流数据
//        //其它参数，根据项目而定，比如我的项目中要传入的参数是json格式的
//        list.add(new KeyValue("parameters", json.toString()));
        //创建MultipartBody
        MultipartBody body = new MultipartBody(list, "UTF-8");
        //添加请求参数
        params.setRequestBody(body);
//
        File file=new File(path);
        boolean flag=file.exists();
//        params.addBodyParameter("file",file);

        x.http().post(params, new Callback.CommonCallback<String>() {

            @Override
            public void onSuccess(String result) {
                String data=result;
                listener.success(data);
            }

            @Override
            public void onError(Throwable ex, boolean isOnCallback) {
                Log.e(TAG, "onError: "+ex.getMessage(),ex );
                listener.error(ex);
            }

            @Override
            public void onCancelled(CancelledException cex) {

            }

            @Override
            public void onFinished() {

            }
        });

        return  flg;
    };

}
