package cn.com.bril.androidocr.studio.ui.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import java.util.List;

import cn.com.bril.androidocr.studio.R;
import cn.com.bril.androidocr.studio.beans.OcrInfo;

/**
 * Created by sunny on 2018-3-19.
 */

public class FragmentListAdapter extends BaseAdapter {

    private Context context;
    private List<OcrInfo> infos;

    public FragmentListAdapter(Context context, List<OcrInfo> list) {
        this.context=context;
        this.infos=list;
    }

    @Override
    public int getCount() {
        return infos.size();
    }

    @Override
    public Object getItem(int position) {
        return infos.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ViewHolder holder;
        if(convertView==null){
            holder=new ViewHolder();
            convertView= LayoutInflater.from(context).inflate(R.layout.listview_item_layout,null);
            holder.title= (TextView)convertView .findViewById(R.id.title);
            holder.time= (TextView) convertView.findViewById(R.id.time);
            convertView.setTag(holder);
        }else
            holder= (ViewHolder) convertView.getTag();

        OcrInfo info=infos.get(position);
        holder.time.setText(info.getLastUpdateTime());
        String fileName=info.getFileName().substring(0,info.getFileName().indexOf("."));
        holder.title.setText(fileName);

        return convertView;
    }
    class ViewHolder{
        TextView title,time;
    }
}
