package cn.com.bril.androidocr.studio.ui.fragment;

import android.content.Context;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;
import android.widget.Toast;

import com.google.gson.reflect.TypeToken;

import org.xutils.common.Callback;
import org.xutils.http.RequestParams;
import org.xutils.x;

import java.util.ArrayList;
import java.util.List;

import cn.com.bril.androidocr.studio.R;
import cn.com.bril.androidocr.studio.beans.OcrInfo;
import cn.com.bril.androidocr.studio.configs.Configs;
import cn.com.bril.androidocr.studio.configs.RequestConfig;
import cn.com.bril.androidocr.studio.ui.adapter.FragmentListAdapter;
import cn.com.bril.androidocr.studio.ui.pulltorefresh.PullToRefreshBase;
import cn.com.bril.androidocr.studio.ui.pulltorefresh.PullToRefreshListView;
import cn.com.bril.androidocr.studio.utils.GsonUtil;
import cn.com.bril.androidocr.studio.utils.HttpUtil;

/**
 * Created by sunny on 2018-3-12.
 */

public class ShareFragment extends Fragment {


    private PullToRefreshListView pullToRefreshListView;
    private ListView listView;
    private Context context;
    private FragmentListAdapter adaper;
    private List<OcrInfo> infos;
    private boolean isUpdate=false,hasMoreData=false;
    private int page=1,pageSize=10;

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        this.context=context;
    }

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        View view=inflater.inflate(R.layout.listview_layout,null);

        initViews(view);

        initEvents();

        return view;
    }

    public void initViews(View view){

        pullToRefreshListView= (PullToRefreshListView) view.findViewById(R.id.pullrefreshView);
        listView=pullToRefreshListView.getRefreshableView();
        pullToRefreshListView.doPullRefreshing(true,500);
        adaper=new FragmentListAdapter(context,infos=new ArrayList<>());
        listView.setAdapter(adaper);


    }

    public void initEvents(){

        pullToRefreshListView.setOnRefreshListener(new PullToRefreshBase.OnRefreshListener<ListView>() {
            @Override
            public void onPullDownToRefresh(PullToRefreshBase<ListView> refreshView) {
                isUpdate=true;
                hasMoreData=true;
                page=1;
                if(HttpUtil.isNetworkConnected(context))
                    getShareRecord();
                else{
                    Toast.makeText(context,"暂无网络连接",Toast.LENGTH_LONG).show();
                    refreshView.onPullDownRefreshComplete();
                }
            }

            @Override
            public void onPullUpToRefresh(PullToRefreshBase<ListView> refreshView) {
                isUpdate=false;
                page++;
                if(HttpUtil.isNetworkConnected(context))
                    getShareRecord();
                else{
                    Toast.makeText(context,"暂无网络连接",Toast.LENGTH_LONG).show();
                    refreshView.onPullDownRefreshComplete();
                }

            }
        });
    }
    private void getShareRecord(){

        RequestParams params=new RequestParams(RequestConfig.EXPORT_LIST_URL);
        params.addBodyParameter("page",page+"");
        params.addBodyParameter("sortItem","create_time");
        params.addBodyParameter("sortOrder","desc");
        String userInfo= Configs.USER_NAME+"_"+Configs.USER_ID;
        String json="{\"cc_ocr_file\":{\"upload_user\":{\"equalTo\":\""+userInfo+"\"},\"status\":{\"equalTo\":\"1\"}}}";
        params.addBodyParameter("filters",json);
        x.http().post(params, new Callback.CommonCallback<String>() {
            @Override
            public void onSuccess(String result) {
               String data=result;
                List<OcrInfo> list = GsonUtil.getInstance().fromJson(data, new TypeToken<List<OcrInfo>>() {}.getType());
                if(isUpdate)
                    infos.clear();
                infos.addAll(list);
                if(list.size()<10){
                    if (list.size()==0)
                        Toast.makeText(context,"暂无数据",Toast.LENGTH_SHORT).show();
                    else{
                        hasMoreData=false;
                        Toast.makeText(context,"无更多数据",Toast.LENGTH_SHORT).show();
                    }

                }
                else
                    hasMoreData=true;

                adaper.notifyDataSetChanged();
//                List<OcrInfo> list=result;
                pullToRefreshListView.onPullUpRefreshComplete();
                pullToRefreshListView.onPullDownRefreshComplete();
                pullToRefreshListView.setHasMoreData(hasMoreData);
            }

            @Override
            public void onError(Throwable ex, boolean isOnCallback) {
                pullToRefreshListView.onPullUpRefreshComplete();
                pullToRefreshListView.onPullDownRefreshComplete();

            }

            @Override
            public void onCancelled(CancelledException cex) {

            }

            @Override
            public void onFinished() {

            }
        });


    }

}
